/*
 * Raid 2: The Return of Saddam
 * Copyright (c) 2008 Steven Wallace / Chedda Cheeze
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */

// Building

#include <stdlib.h>
#include <GL/gl.h>

#define IN_BUILDING_CC
#include "Building.h"

Building::Building(int x, int y, float height) {
	this->x = x;
	this->y = y;
	this->height = height;
	alive = true;
	color = 1 + rand()%3;
}

void Building::Draw() {
	glDisable(GL_LIGHTING);
	if(!alive) color = 0;
	glBegin(GL_QUADS);
		glColor3fv(color_building[color][0]);
		glNormal3f(0, 0, -1);
		glVertex3f(x, 0, y);
		glVertex3f(x, height, y);
		glVertex3f(x+10, height, y);
		glVertex3f(x+10, 0, y);
	
		glColor3fv(color_building[color][1]);
		glNormal3f(1, 0, 0);
		glVertex3f(x+10, 0, y);
		glVertex3f(x+10, height, y);
		glVertex3f(x+10, height, y+10);
		glVertex3f(x+10, 0, y+10);
	
		glColor3fv(color_building[color][2]);
		glNormal3f(0, 0, 1);
		glVertex3f(x+10, 0, y+10);
		glVertex3f(x+10, height, y+10);
		glVertex3f(x, height, y+10);
		glVertex3f(x, 0, y+10);
	
		glColor3fv(color_building[color][3]);
		glNormal3f(-1, 0, 0);
		glVertex3f(x, 0, y+10);
		glVertex3f(x, height, y+10);
		glVertex3f(x, height, y);
		glVertex3f(x, 0, y);
		
		glColor3fv(color_building[color][4]);
		glNormal3f(0, 1, 0);
		glVertex3f(x, height, y);
		glVertex3f(x, height, y+10);
		glVertex3f(x+10, height, y+10);
		glVertex3f(x+10, height, y);
	glEnd();
	
	glEnable(GL_LIGHTING);
}

bool Building::isInside(float x, float y, float z) {
	if(x >= this->x 
	&& x <= this->x + 10 
	&& z >= this->y 
	&& z <= this->y + 10 
	&& y <= this->height
	&& y >= 0.0) {
		return true;
	}
	return false;
}
