/*
 * Raid 2: The Return of Saddam
 * Copyright (c) 2008 Steven Wallace / Chedda Cheeze
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */

// Explosion class
#ifndef _EXPLOSION_H
#define _EXPLOSION_H

#define EX_TYPE_SMOKE		0
#define EX_TYPE_FIRE		1
#define EX_TYPE_PARTICLE	2

class Explosion {
public:
	Explosion(float x, float y, float z, int type);

	bool Update(float dt);
	void Draw();


	float x, y, z;		// Position
	float dx, dy, dz;	// Movement
	int frame;		// Each type is a still image, but there are many different ones
	float ttl;			// Time to live -- determines transparency
	float decay_rate;	// Rate at which it dies
	float angle;		// angle
	float rotate_speed;// Speed of rotation in degrees per second
};

#endif // _EXPLOSION_H
