/*
 * Raid 2: The Return of Saddam
 * Copyright (c) 2008 Steven Wallace / Chedda Cheeze
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */

// Music
#ifndef _MUSIC_H
#define _MUSIC_H

#include <pthread.h>
#include <vector>
using namespace std;

class Song {
public:
	Song(const char *url, const char *title);

	char url[1024];
	char *filename;	// Points to the filename portion of url
	char title[1024];
	bool available;
};




class Music {
public:
	Music(const char *filename);


	char *StatusString();
	vector<Song*> song;
	vector<Song*> available_song;
	
	void PlayFirstSong();
	void PlayLastSong();
	void PlayRandomSong();
	void PlaySong(int idx);

	// Checks if the current song is over.  If so, it plays a new one
	void PollMusic(float dt);

	// "Now playing" data
	int voice;
	struct SAMPLE *sample;
	int playing_idx;
	float timer;
	pthread_t load_thread;

	// Fetching interface
	float fetch_progress;
	int fetch_idx;
	pthread_t fetch_thread;
};



#endif // _MUSIC_H
