/*
 * Raid 2: The Return of Saddam
 * Copyright (c) 2008 Steven Wallace / Chedda Cheeze
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */

// Wave structure
#ifndef _WAVE_H
#define _WAVE_H

#include <stdio.h>
#include <queue>
using namespace std;

#define WAVE_CMD_WAIT		0
#define WAVE_CMD_PLANE	1

class WaveBit{
public:
	int cmd;
	float value;
};


class Wave {
public:
	float timer, next_timer;
	bool stop;

	// Next instruction
	queue<WaveBit*> command;

	Wave(const char *filename);
	~Wave();

	bool Update(float dt);
};

#endif // _WAVE_H
